#include "HelloWorldScene.h"
#include "spine/Json.h"

#define APPLICATIONID "X-Parse-Application-Id: xxxxxx"
#define APIKEY "X-Parse-REST-API-Key: xxxxxx"

USING_NS_CC;


Scene* HelloWorld::createScene()
{
  // 'scene' is an autorelease object
  auto scene = Scene::create();
  
  // 'layer' is an autorelease object
  auto layer = HelloWorld::create();
  
  // add layer as a child to scene
  scene->addChild(layer);
  
  // return the scene
  return scene;
}

// on "init" you need to initialize your instance
bool HelloWorld::init()
{
  //////////////////////////////
  // 1. super init first
  if ( !Layer::init() )
  {
    return false;
  }
  
  Size visibleSize = Director::getInstance()->getVisibleSize();
  Vec2 origin = Director::getInstance()->getVisibleOrigin();
  
  // http
  std::vector<std::string> httpdHeader;
  httpdHeader.push_back(APPLICATIONID);
  httpdHeader.push_back(APIKEY);
  httpdHeader.push_back("Content-Type: application/json");

  // Get
  auto request = new cocos2d::network::HttpRequest();
  request->setUrl("https://api.parse.com/1/classes/GameScore/");
  request->setHeaders(httpdHeader);
  request->setRequestType(cocos2d::network::HttpRequest::Type::GET);
  
  cocos2d::network::HttpClient::getInstance()->send(request);
  request->release();
  
  //callback
  request->setResponseCallback(CC_CALLBACK_2(HelloWorld::onHttpRequestCompleted, this));
   
//  POST
  auto request = new cocos2d::network::HttpRequest();
  request->setUrl("https://api.parse.com/1/classes/GameScore");
  request->setHeaders(httpdHeader);
  request->setRequestType(cocos2d::network::HttpRequest::Type::POST);
  auto postdata = "{\"score\":1337,\"playerName\":\"Sean Plott\",\"cheatMode\":false}";
  const char* buf = postdata;
  request->setRequestData(buf, strlen(buf));
  cocos2d::network::HttpClient::getInstance()->send(request);
  request->release();
  
  //callback
  request->setResponseCallback(CC_CALLBACK_2(HelloWorld::onHttpRequestCompleted, this));

  // PUT
  auto request = new cocos2d::network::HttpRequest();
  request->setUrl("https://api.parse.com/1/classes/GameScore/7NvZrgmzfF");
  request->setHeaders(httpdHeader);
  request->setRequestType(cocos2d::network::HttpRequest::Type::PUT);
  auto putdata = "{\"score\":1000,\"playerName\":\"mett Plott\",\"cheatMode\":false}";
  const char* buffer = putdata;
  request->setRequestData(buffer, strlen(buffer));
  cocos2d::network::HttpClient::getInstance()->send(request);
  request->release();

  //callback
  request->setResponseCallback(CC_CALLBACK_2(HelloWorld::onHttpRequestCompleted, this));
  
  return true;
}


void HelloWorld::onHttpRequestCompleted(cocos2d::network::HttpClient *client,
                                        cocos2d::network::HttpResponse *response)
{
  if (response->isSucceed()) {
    std::vector<char> *buffer = response->getResponseData();
    
    char * concatenated = (char *) malloc(buffer->size() + 1);
    std::string s2(buffer->begin(), buffer->end());
    strcpy(concatenated, s2.c_str());
    
    char data[buffer->size()];
    for (int i = 0; i < buffer->size(); i++) {
      data[i] = buffer->at(i);
      printf("%c", buffer->at(i));
    }
  }
  
  //if (response->isSucceed()) {
  //  std::vector<char> *buffer = response->getResponseData();

  //  std::string stdString(buffer->begin(), buffer->end());
  //  const char *cStr = stdString.c_str();

  //  Json* json = Json_create(cStr);
  //  auto jsonArray = Json_getItem(json, "results");

  //  Json* item = nullptr;
  //  for (int i = 0; i < jsonArray->size; i++) {
  //    if(item == nullptr) {
  //      item = jsonArray->child;
  //    } else {
  //      item = item->next;
  //    }
  //    log("%d", Json_getInt(item, "score", 0));
  //  }
  //}
}

