#include "HelloWorldScene.h"


USING_NS_CC;

Scene* HelloWorld::createScene()
{
    // 'scene' is an autorelease object
    auto scene = Scene::create();
    
    // 'layer' is an autorelease object
    auto layer = HelloWorld::create();

    // add layer as a child to scene
    scene->addChild(layer);

    // return the scene
    return scene;
}

// on "init" you need to initialize your instance
bool HelloWorld::init()
{
  //////////////////////////////
  // 1. super init first
  if ( !Layer::init() )
  {
      return false;
  }
  
  Size visibleSize = Director::getInstance()->getVisibleSize();
  Vec2 origin = Director::getInstance()->getVisibleOrigin();
  
  //EditBox
  bkSprite = Scale9Sprite::create("sprite9.png");
  _editbox = EditBox::create(cocos2d::Size(600,80), bkSprite);
  _editbox->setPosition(Vec2((visibleSize.width / 2) - 100 ,80));
  _editbox->setFontColor(Color3B(0,0,0));
  _editbox->setReturnType(EditBox::KeyboardReturnType::DEFAULT);
  _editbox->setPlaceHolder("message...");
  _editbox->setMaxLength(140);
  
  _editbox->setDelegate(this);
  this->addChild(_editbox);
  
  //SendButton
  Label* _sendBtnLabel = Label::createWithSystemFont("Send", "Ariel", 32);
  _sendBtnLabel->setColor(Color3B(0,0,0));
  
  ControlButton* _sendBtn = ControlButton::create(_sendBtnLabel, Scale9Sprite::create("sprite9.png"));
  _sendBtn->setPosition(Vec2((visibleSize.width / 2) + 250, 80));
  _sendBtn->setPreferredSize(cocos2d::Size(Vec2(100,80)));
  
  _sendBtn->addTargetWithActionForControlEvents(this, cccontrol_selector(HelloWorld::sendCallBack), Control::EventType::TOUCH_UP_INSIDE);
  
  this->addChild(_sendBtn);

  _recieveLabel = LabelTTF::create("", "arial", 48);
  _recieveLabel->setPosition(Vec2(visibleSize / 2));
  _recieveLabel->setColor(Color3B(255, 0, 0));
  
  this->addChild(_recieveLabel);
  
  AppWarp::Client *warpClientRef;
  AppWarp::Client::initialize(APPWARP_APP_KEY,APPWARP_SECRET_KEY);
  warpClientRef = AppWarp::Client::getInstance();
  warpClientRef->setConnectionRequestListener(this);
  warpClientRef->setNotificationListener(this);
  warpClientRef->setRoomRequestListener(this);
  warpClientRef->setZoneRequestListener(this);
  
  userName = genRandom();
  warpClientRef->connect(userName);
  
  return true;
}

std::string HelloWorld::genRandom()
{
  std::string charStr;
  srand (time(NULL));
  
  for (int i = 0; i < 10; ++i) {
    charStr += (char)(65+(rand() % (26)));
  }
  
  return charStr;
}


void HelloWorld::onConnectDone(int res)
{
  if (res==0)
  {
    printf("\nonConnectDone .. SUCCESS\n");
    AppWarp::Client *warpClientRef;
    warpClientRef = AppWarp::Client::getInstance();
    warpClientRef->joinRoom(ROOM_ID);
  }
  else
    printf("\nonConnectDone .. FAILED\n");
  
}

void HelloWorld::onJoinRoomDone(AppWarp::room revent)
{
  if (revent.result==0)
  {
    printf("\nonJoinRoomDone .. SUCCESS\n");
    AppWarp::Client *warpClientRef;
    warpClientRef = AppWarp::Client::getInstance();
    warpClientRef->subscribeRoom(ROOM_ID);

  }
  else
    printf("\nonJoinRoomDone .. FAILED\n");
}

void HelloWorld::onSubscribeRoomDone(AppWarp::room revent)
{
  if (revent.result==0)
  {
    printf("\nonSubscribeRoomDone .. SUCCESS\n");
  }
  else
    printf("\nonSubscribeRoomDone .. FAILED\n");
}

void HelloWorld::sendChat(std::string str)
{
  
}


void HelloWorld::editBoxEditingDidBegin(EditBox* editBox) {
  log("input data : %s", editBox->getText());
}

void HelloWorld::editBoxEditingDidEnd(EditBox* editBox){
  log("input data : %s", editBox->getText());
  //_label->setString(editBox->getText());
}

void HelloWorld::editBoxTextChanged(EditBox* editbox, const std::string& text){
  log("input data : %s", text.c_str());
}

void HelloWorld::editBoxReturn (EditBox *editBox){
  log("input data : %s", editBox->getText());
}

void HelloWorld::sendCallBack(Ref *senderz, Control::EventType controlEvent){
  log("label : %s", _editbox->getText());
  
  std::string sendData = _editbox->getText();
  
  if (sendData != "") {
    AppWarp::Client *warpClientRef;
    warpClientRef = AppWarp::Client::getInstance();
    
    warpClientRef->sendChat(sendData);
  }
  
  return;
}

void HelloWorld::onChatReceived(AppWarp::chat chatevent)
{
  
  std::string chatData;
  chatData = chatevent.chat.c_str();
  
  _recieveLabel->setString(chatData);
  
  printf("onChatReceived..");
  printf("%s : %s ", chatevent.sender.c_str(), chatevent.chat.c_str());
}